#include <iostream>
#define N 14
#define M 20


using namespace std;

/* A utility function to print solution in triangle */
void printSolution(int board[M][M])
{
    for (int i = 0; i < M; i++)
    {
        int j;
        for (j = 0; j <= M - i; j++)
            cout << " ";
        for (j = 0; j <= i; j++)
            cout << (board[i][j]) << " ";
        cout << endl;
    }
}

/* A utility function to check if a queen can be placed on board[row][col]
   Note that this function is called when "col" queens are already placeed
   in columns from 0 to col -1. So we need to check only left side for
   attacking queens */
bool isSafe(int board[M][M], int row, int col)
{
    int i, j;

    /* Check this row on left side */
    for (i = 0; i < col; i++)
    {
        if (board[row][i])
            return false;
    }

    /* Check upper diagonal on left side */
    for (i = row, j = col; i >= 0 && j >= 0; i--, j--)
    {
        if (board[i][j])
            return false;
    }

      /* Check lower diagonal on left side */
     for (i = row, j = col; i >= 0 && j >= 0; i--, j++)
    {
        if (board[i][j])
            return false;
    }


    return true;
}

/* A recursive utility function to solve N Queen problem */
bool solveNQUtil(int board[M][M], int col)
{
    /* base case: If all queens are placed then return true */
    if (col >= N)
        return true;

    /* Consider this column and try placing this queen in all rows
       one by one */
    for (int i = col; i < M; i++)
    {
        /* Check if queen can be placed on board[i][col] */
        if ( isSafe(board, i, col) )
        {
            /* Place this queen in board[i][col] */
            board[i][col] = 1;

            /* recur to place rest of the queens */
            if ( solveNQUtil(board, col + 1) == true )
                return true;

            /* If placing queen in board[i][col] doesn't lead to a solution
               then remove queen from board[i][col] */
            board[i][col] = 0; // BACKTRACK
        }
    }

     /* If queen can not be place in any row in this colum col
        then return false */
    return false;
}

/* This function solves the N Queen problem using Backtracking.  It mainly uses
solveNQUtil() to solve the problem. It returns false if queens cannot be placed,
otherwise return true and prints placement of queens in the form of 1s. Please
note that there may be more than one solutions, this function prints one of the
feasible solutions.*/
bool solveNQ()
{
    int board[M][M] = { { } };
    if ( solveNQUtil(board, 0) == false )
    {
        cout << ("Solution does not exist");
        return false;
    }

    printSolution(board);
    return true;
}

// driver program to test above function
int main()
{
    solveNQ();

    return 0;
}
